package com.hongyegroup.cpt_parttime.ui.main

import android.os.Bundle
import android.view.View
import com.guadou.cs_cptservices.base.fragment.YYBaseVDBLoadingFragment
import com.guadou.cs_cptservices.interfaces.IFragmentRefresh
import com.guadou.lib_baselib.bean.DataBindingConfig
import com.guadou.lib_baselib.utils.CommUtils
import com.guadou.lib_baselib.view.gloading.GLoadingTitleStatus
import com.guadou.lib_baselib.view.gloading.Gloading
import com.guadou.lib_baselib.view.gloading.GloadingGlobalAdapter
import com.hongyegroup.cpt_parttime.BR
import com.hongyegroup.cpt_parttime.R
import com.hongyegroup.cpt_parttime.databinding.FragmentParttimeJobProfileBinding
import com.hongyegroup.cpt_parttime.mvvm.PartJobProfileViewModel
import com.hongyegroup.cpt_parttime.ui.PartJobEditProfileInfoActivity
import com.hongyegroup.cpt_parttime.widget.UserUrgentAlertPopup
import com.lxj.xpopup.XPopup
import com.scwang.smart.refresh.layout.api.RefreshLayout
import com.scwang.smart.refresh.layout.listener.OnRefreshListener

/**
 * 兼职个人信息页面
 */
class PartTimeProfileFragment : YYBaseVDBLoadingFragment<PartJobProfileViewModel, FragmentParttimeJobProfileBinding>(), IFragmentRefresh,
    OnRefreshListener {

    override fun getDataBindingConfig(): DataBindingConfig {
        return DataBindingConfig(R.layout.fragment_parttime_job_profile, BR.viewModel, mViewModel)
            .addBindingParams(BR.click, ClickProxy())
    }

    //重新生成GLoading对象-跳动动画
    override fun generateGLoading(view: View): Gloading.Holder {
        return Gloading.from(GloadingGlobalAdapter())
            .wrap(view, GLoadingTitleStatus(true, true, true))
            .withRetry { onGoadingRetry() }
    }

    override fun startObserve() {
    }

    override fun init(savedInstanceState: Bundle?) {
        initData()
        initListener()
    }


    private fun initData() {
        showStateLoading()
        CommUtils.getHandler().postDelayed({
            showStateSuccess()

//            popupPartTimeProfile()
        }, 1500)
    }

//    private fun popupPartTimeProfile() {
//        val mRatingView = mBinding.viewStubRating.viewStub?.inflate()
//
//        val mRateBinding = DataBindingUtil.bind<IncludePensonalTurnUpRateBinding>(mRatingView!!)
//
//        mRateBinding?.turnUpProgress?.setValue("60", 100f)
//    }

    override fun onGoadingRetry() {

    }

    private fun initListener() {

    }

    override fun onRefresh(refreshLayout: RefreshLayout) {

    }

    override fun scrollTopRefresh() {

    }

    /**
     * DataBinding事件处理
     */
    inner class ClickProxy {

        //跳转到编辑个人信息界面
        fun editProfileInfo() {
            PartJobEditProfileInfoActivity.startInstance()
        }

        //审核个人信息加急
        fun userUrgent() {
            //弹窗展示以及申请成功
            XPopup.Builder(mActivity)
                .hasShadowBg(true)
                .asCustom(UserUrgentAlertPopup(mActivity))
                .show()
        }

    }

}